=== debian/changelog ===
poc-streamer (0.4.2-5) unstable; urgency=medium

  * QA upload.
  * Migrated DebSrc to 3.0 format. Consequently, moved all previous patches
    to individual files in debian/patches (patches 010 to 060).
  * Using new DH level format. Consequently:
      - debian/compat: removed.
      - debian/control: changed from 'debhelper' to 'debhelper-compat' in
        Build-Depends field and bumped level to 12.
  * debian/control:
      - Added 'Rules-Requires-Root: binary-targets' to source stanza.
      - Bumped Standards-Version to 4.5.0.
      - Created VCS fields.
  * debian/copyright:
      - Migrated to 1.0 format.
      - Updated all information.
  * debian/dirs: not needed. Removed.
  * debian/patches/070_add-GCC-hardening.patch: created to provide GCC
    hardening.
  * debian/salsa-ci.yml: added to provide CI tests for Salsa.
  * debian/tests/control: created to perform a trivial CI test.
  * debian/watch:
      - Bumped version to 4.
      - Improved the rule to search new versions.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 11 Apr 2020 19:53:30 -0300

poc-streamer (0.4.2-4) unstable; urgency=low

  * Set maintainer to Debian QA Group, as this package is now orphaned.

 -- Mike Gerber <mike@sprachgewalt.de>  Fri, 23 Dec 2016 17:12:36 +0100

poc-streamer (0.4.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.

    [ Joao Eriberto Mota Filho ]

  * Bumped DH level to 10. (Closes: #817623)
  * debian/control:
      - Added a Homepage field.
      - Added the libfl-dev to Build-Depends field to avoid a FTBFS.
      - Bumped Standards-Version to 3.9.8.
  * debian/rules:
      - After conversion made by Logan:
          ~ Added DEB_BUILD_MAINT_OPTIONS variable to improve the GCC hardening.
          ~ Added DEB_LDFLAGS_MAINT_APPEND variable to avoid unneeded linking
            against libraries.

    [ Logan Rosen ]

  * debian/control: remove article from beginning of synopsis.
  * debian/rules:
    - Convert to dh sequencer.
    - Disable dh_auto_test since test.sh in test target doesn't exist.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 21 Dec 2016 01:50:09 -0200

poc-streamer (0.4.2-3) unstable; urgency=low

  * Remove Joachim Breitner from "Uploaders", as he requested
  * Apply patches from upstream's svn repository:
    * Fix problems with MP3s with faulty frame sizes (possible buffer overflow)
    * Fix time formatting
    * Fix typo in manpage

 -- Mike Gerber <mike@sprachgewalt.de>  Fri, 29 Apr 2005 21:59:54 +0200

poc-streamer (0.4.2-2) unstable; urgency=low

  * Add flex and build-dependencies to fix FTBFS bugs
  * Fix FTBFS on 64-bit platforms: as ssize_t is not an int there,
    fec-pkt.c failed to build due to incompatible types

 -- Mike Gerber <mike@sprachgewalt.de>  Fri, 29 Apr 2005 02:38:53 +0200

poc-streamer (0.4.2-1) unstable; urgency=low

  * Initial upload (Closes: #296448)
  * Rename source-package from poc to poc-streamer to avoid a conflict
    with objc-poc which was formerly known as poc

 -- Mike Gerber <mike@sprachgewalt.de>  Mon, 18 Apr 2005 18:34:43 +0200
