=== debian/control ===
Source: poc-streamer
Section: sound
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 12), libid3tag0-dev, flex, bison, libfl-dev
Standards-Version: 4.5.0
Rules-Requires-Root: binary-targets
Homepage: https://bl0rg.net/software/poc/
Vcs-Browser: https://salsa.debian.org/debian/poc-streamer
Vcs-Git: https://salsa.debian.org/debian/poc-streamer.git

Package: poc-streamer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: MP3/Ogg multicast/HTTP streamer and MP3 cutting tool
 poc is a suite of MP3 tools and MP3 streaming programs. It can stream
 MP3s over HTTP, RTP multicast (RFC 2250 and RFC 3119) and a special
 multicast protocol to enable the use of Forward Error Correction to
 protect the MP3 stream against packet loss. It can also stream OGGs
 over HTTP.
 .
 In addition to the streaming programs, poc contains two MP3 tools:
 mp3cue and mp3cut. mp3cue can cut a big MP3 file according to a
 tracklisting contained in a .cue file. mp3cut can split and
 concatenate MP3 files according to time slices given on the command
 line. mp3cut cuts MP3 files on ADU (autonomous data units) frames
 to ensure best quality.
