=== debian/tests/control ===
Test-Command: mp3cue

Test-Command: mp3cut | grep Usage

Test-Command: mp3length 2>&1 | grep Usage

Test-Command: pob-2250 2>&1 | grep bind

Test-Command: pob-3119 2>&1 | grep bind

Test-Command: pob-fec 2>&1 | grep bind

Test-Command: poc-2250 2>&1 | grep Usage

Test-Command: poc-3119 2>&1 | grep Usage

Test-Command: poc-fec 2>&1 | grep Usage

Test-Command: poc-http 2>&1 | grep Usage

Test-Command: pogg-http 2>&1 | grep Usage
