=== debian/watch ===
version=4
https://bl0rg.net/software/poc/poc-(\d\S+)\.tar\.(?:bz2|gz|xz)
